
%global _product_name oVirt Node Next
%global _product_id ovirt-node-ng

%global	_node_image_dir /usr/share/%{name}/image/
%global	_node_image_file %{_node_image_dir}/%{name}-%{version}-%{release}.squashfs.img
%global	_node_tools_dir /usr/share/%{name}/tools/

%global with_image 0

# Hardcode the dist to el7, because this is what the image contains
# This is also hardcoded, because currently the el7 rpms are built
# on F22 builders. Thus the dist would be wrong.
%global dist .el7

%global with_docs 0
%global with_tools 0

# Disable compression, because the image is already compressed
%define _source_payload w0.gzdio
%define _binary_payload w0.gzdio

Name:       %{_product_id}
Version:    4.0.4
Release:    0.20160812.0%{?dist}%{?extra_release}
License:    GPLv2
Summary:    %{_product_name}

URL:        http://www.ovirt.org/node/
Source0:    %{name}-4.0.4.tar.gz
%if 0%{?with_image}
Source1:    ovirt-node-ng-image.squashfs.img
Source2:    product.img
%endif
BuildArch:  noarch

BuildRequires: autoconf
BuildRequires: automake

%description
This package provides some tooling around building %{_product_name}.
Currently the main package is empty.

%if 0%{?with_image}
# IMPORTANT
# The image and image-updat version and release are inherited
# from the ovirt-node-ng-image-update-placeholder package
# There is a lot of fu to support this.
%package image
Summary: %{_product_name} Image
Version:    
Release:    

%description image
This package contains the prebuild %{_product_name} image.
It can be used to create the %{_product_name} installer.

%package image-update
Summary:    %{_product_name} Image Update
Version:    
Release:    
Requires:   %{_product_id}-image = %{version}-%{release}
Requires:   imgbased >= 0.7.2

Obsoletes:  %{_product_id}-image-update-placeholder < %{version}-%{release}
Provides:  %{_product_id}-image-update-placeholder = %{version}-%{release}

%description image-update
This package will update an %{_product_name} host with the new image.
%endif

%if 0%{?with_docs}
%package docs
Summary:     Documentation for %{_product_name}

%description docs
Subpackage for docs related to %{_product_name}
%endif

%if 0%{?with_tools}
%package tools
Summary:     Tools for %{_product_name}

%description tools
Subpackage for tools related to %{_product_name}
%endif

%package -n nodectl
Summary:     nodectl for %{name}
Requires:    imgbased

%description -n nodectl
Subpackage for nodectl for %{name}

%prep
%setup -q -n %{name}-4.0.4

%build
%configure
make %{?_smp_mflags}

%install
%make_install

%if 0%{?with_image}
# Install the image
/usr/bin/install -d %{buildroot}/%{_node_image_dir}
/usr/bin/install -m 644 %{SOURCE1} %{buildroot}/%{_node_image_file}
/usr/bin/install -m 644 %{SOURCE2} %{buildroot}/%{_node_image_dir}/product.img

%post image-update
# Some magic to ensure that imgbase from
# the new image is used for updates
export TMPDIR="$(mktemp -d)"
mount "%{_node_image_file}" "$TMPDIR"
mount "$TMPDIR"/LiveOS/rootfs.img "$TMPDIR"
export PYTHONPATH="$TMPDIR"/usr/lib/python2.7/site-packages/:$PYTHONPATH
imgbase --debug update --format liveimg %{_node_image_file} >> /tmp/imgbased.log 2>&1
unset PYTHONPATH
umount "$TMPDIR"
umount "$TMPDIR"
rmdir "$TMPDIR"

%files image
%dir %{_node_image_dir}
%{_node_image_file}
%{_node_image_dir}/product.img

%files image-update
# Empty, just the post-let is relevant
%endif

%files -n nodectl
%{_mandir}/man8/nodectl.8.gz
%{_sbindir}/nodectl
%{python_sitelib}/nodectl

%if 0%{?with_docs}
%files docs
%{_docdir}/%{name}/*
%else
%exclude %{_docdir}/%{name}/*
%endif

%if 0%{?with_tools}
%files tools
%dir %{_node_tools_dir}
%{_node_tools_dir}/*
%{_bindir}/create-node-installation-iso
%else
%exclude %{_node_tools_dir}/*
%exclude %{_bindir}/create-node-installation-iso
%endif

%changelog
* Sat Jul 9 2016 Ryan Barry <rbarry@redhat.com>
- Add nodectl
* Mon Jan 25 2016 Douglas Schilling Landgraf <dougsland@redhat.com>
- Initial build
